# -*- coding: cp1252 -*-
# (C) by Fred Bayer <fred@bayerf.de>
#
# Creates a PostScript page containing the B7971 font

from b7971font import segments, chars, printable

if "UML" in chars:
  PSFILE=r"b7971font_uml.ps"
else:
  PSFILE=r"b7971font.ps"

ps="""\
/Helvetica findfont 36 scalefont setfont
120 770 moveto
(B7971 font for the F4LW) show
gsave
50 200 translate
33 33 scale
0.08 setlinewidth
0 0 moveto
16 0 rlineto
0 16 rlineto
16 neg 0 rlineto
closepath
stroke
0.03 setlinewidth
0 2 16
{dup 0 exch moveto
 16 0 rlineto stroke
} for
0 1 16
{dup 0 moveto
 0 16 rlineto stroke
} for
1 setlinejoin 1 setlinecap
/Times-Roman findfont
dup length dict begin
  {1 index /FID ne {def} {pop pop} ifelse} forall
  /Encoding ISOLatin1Encoding def
  currentdict
end
/ExplFont exch definefont pop
/ExplFont findfont 36 scalefont setfont
"""

ps1="""\
grestore
showpage
"""

def drawLine(x1,y1,x2,y2,x3=None,y3=None):
  res = "%d %d moveto %d %d lineto" % (x1,y1,x2,y2)
  if x3 and y3:
    res += " %d %d lineto" % (x3,y3)
  return res + " stroke\n"
    
def drawChar(n):
  x = n%16
  y = 7-n//16
  res = "gsave %f %f translate\n 0.004 0.004 scale 9 setlinewidth\n" % (x+0.5,2.0*y+0.8)
  for i,d in enumerate(chars[chr(n)][0:16]):
    if int(d):
      res += drawLine(*segments[i])
  cname = printable(chr(n)).replace("\\","\\\\").replace(")","\\)").replace("(","\\(")
  res += "(%s) dup stringwidth exch -2 div 216 moveto pop show\n" % cname
  return res + "grestore"

def main():
  f=file(PSFILE,"w")
  print >>f, ps
  for n in range(0,128):
    print >>f, drawChar(n)
  print >>f, ps1
  f.close()

if __name__=="__main__":
  main()
