# -*- coding: cp1252 -*-
# (C) by Fred Bayer <fred@bayerf.de>
#
"""\
Create a EEPROM image to upload to the F4LW containing all 4-letter words
in the file <filename> and the transition tables for word chains.
"""

import sys
import os
import words

if __name__ == "__main__":
  if len(sys.argv) != 3:
    sys.stderr.write('usage: makeROM filename tag\n')
    sys.exit(2)
  wfn,tag = sys.argv[1:]
  rfn = os.path.splitext(wfn)[0] + ".f4lw"
  print "Reading word list " + wfn
  words.setWordlist(wfn)
  print "Building chains (be patient)"
  chain = words.Chain(4)
  print "Creating ROM file " + rfn
  chain.savemem(rfn,tag)
  print "Done"
  
